<?php

/**
 * @package BwlFaqManager
 */

namespace BwlFaqManager\Controllers\Shortcodes;

use BwlFaqManager\Api\Shortcodes\ShortcodesApi;
use BwlFaqManager\Callbacks\Shortcodes\FaqItemsCb;


class FaqList
{
  public $faqItemsCb;
  public $shortcodesApi;

  public function __construct() {}
  public function register()
  {

    //Initialize API.
    $this->shortcodesApi = new ShortcodesApi();

    //Initialize callbacks.
    $this->faqItemsCb = new FaqItemsCb();

    $shortcodes = [
      [
        'tag' => 'bwla_faq', // Primary FAQ Shortcode
        'callback' => [$this->faqItemsCb, 'getFaqItems']
      ]
    ];

    $this->shortcodesApi->addShortcodes($shortcodes)->register();
  }
}