<?php

/**
 * @package BwlFaqManager
 */

namespace BwlFaqManager;

class Init
{

  public static function getServices()
  {

    /**
     * Add plugin required classes.
     * @since 2.0.6
     */

    return [
      // Base\Enqueue::class, // loads all the frontend styles and scripts.
      // Base\AdminEnqueue::class, // loads all the backend styles and scripts.
      // Base\Language::class, // loads the translation file.
      // Base\LoadRequiredFiles::class, // load the required helper files.
      // Base\PluginFilterHandlers::class, // Frontend filters like - search, theme, post view count, attachment, rewrite
      // Base\PluginAdminFilterHandlers::class,
      // Base\PluginActionHandlers::class,
      // Base\PluginAdminActionHandlers::class,
      // Base\PluginAjaxHandlers::class,
      // Base\PluginRewriteRulesHandlers::class,
      // Pages\PluginCpt::class,
      // Pages\CustomColumns::class,
      // Pages\CustomQuickBulkEdit::class,
      // Pages\PluginPages::class,
      // Pages\PluginCustomTaxonomy::class,
      // Pages\PluginOptionsPanel::class,
      // Pages\PluginShortcodes::class,
      // Pages\PluginWidgets::class,
      // Base\PluginUpdater::class,
      // Base\PluginAdminNotices::class,
      // Base\FaqInlineJs::class,
      Base\AboutPluginRedirect::class,
      Controllers\Shortcodes\FaqSearchBox::class, //Faq SearchBox shortcode
      Controllers\Shortcodes\FaqList::class, // Faq List Shortcode.
      Controllers\Shortcodes\FaqAuthor::class, // Faq Author Shortcode.
      Controllers\Shortcodes\FaqSortedList::class, // Faq Dynamic List Shortcode.
      Controllers\Shortcodes\FaqExternalForm::class, // External Faq Form shortcode
      Controllers\Shortcodes\FaqTabs::class, //Faq Tabs shortcode
      Controllers\ExternalFaqForm\FaqSubmissionHandler::class, // Ajax handler for form submission.
      Controllers\Themes\FaqCustomThemes::class,
      Controllers\Votes\FaqVotes::class,
      Controllers\DashboardWidgets\PluginDashboardWidgets::class,
      Controllers\Metainfo\BafMetaInfo::class,
      Controllers\Cpt\BafCptCustomColumns::class, // Load plugin custom columns.
      Controllers\Cpt\BafQuickBulkEdit::class, // Load plugin quick and bulk edit settings.
      Controllers\Cpt\BafCptTaxonomyFilters::class, // Load plugin custom filter by category and tags 
      Controllers\TaxonomySort\BafTaxonomySort::class // Admin panel FAQ sorting.
    ];
  }

  /**
   * Registered all the classes.
   * @since 2.0.6
   */

  public static function registerServices()
  {

    foreach (self::getServices() as $service) {

      $service = self::instantiate($service);

      if (method_exists($service, 'register')) {
        $service->register();
      }
    }
  }

  /**
   * Instantiate all the registered classes.
   * @since 2.0.6
   */

  private static function instantiate($class)
  {
    return new $class();
  }
}